<?php

include("../include/config.php");
include("../include/snmp_functions.php");

// Array that supports index operation
$oids = array(
	"temperature" => ".1.3.6.1.4.1.232.6.2.6.8.1.4",
	"threshold" => ".1.3.6.1.4.1.232.6.2.6.8.1.5",
	"index" => ".1.3.6.1.4.1.232.6.2.6.8.1.2",
	"location" => ".1.3.6.1.4.1.232.6.2.6.8.1.3"
	);

// Array for get operation, real OID's include atached .0 string before index
$oids2 = array(
        "temperature" => ".1.3.6.1.4.1.232.6.2.6.8.1.4.0",
        "threshold" => ".1.3.6.1.4.1.232.6.2.6.8.1.5.0",
        "index" => ".1.3.6.1.4.1.232.6.2.6.8.1.2.0",
        "location" => ".1.3.6.1.4.1.232.6.2.6.8.1.3.0"
        );

$hostname = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$cmd = $_SERVER["argv"][3];

if ($cmd == "index") {
	$return_arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], "1", "", ""));
	
	for ($i=0;($i<sizeof($return_arr));$i++) {
		print $return_arr[$i]["value"] . "\n";
	}
}elseif ($cmd == "query") {
	$arg = $_SERVER["argv"][4];

	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], "1", "", ""));
	$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], "1", "", ""));
	
	for ($i=0;($i<sizeof($arr_index));$i++) {
		if ($arg == "location") {
			$locatio = realloc($arr[$i]);
			print $arr_index[$i] . "!" . $locatio . "\n";
		} else {
			print $arr_index[$i] . "!" . $arr[$i] . "\n";
		}
	}
}elseif ($cmd == "get") {
	$arg = $_SERVER["argv"][4];
	$index = $_SERVER["argv"][5];
	
	print (cacti_snmp_get($hostname, $snmp_community, $oids2[$arg] . ".$index", "1", "", ""));
}

function reindex($arr) {
	$return_arr = array();
	
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}
	
	return $return_arr;
}
function realloc($locarr) {
        $compaqloc = array(
	        	"Other",
        		"Unknown",
        		"System",
        		"SystemBoard",
        		"ioBoard",
        		"CPU",
        		"Memory",
        		"Storage",
        		"RemovableMedia",
        		"PowerSupply"
			);

        for ($c=1;($c<=10);$c++) {
                if ($locarr == $c) {
                        $loc = $compaqloc[$c-1];
		}
        }

        return $loc;
}

?>
